import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillbs', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:bs_active_control':
          player.runCommandAsync('execute as @s[tag=bs_user,tag=!inlight,tag=!tse] at @s run function bs_active');
          break;
        case 'jjba:bs_disabled_control':
          player.runCommandAsync('execute as @s[tag=bs_user,tag=!nrr,tag=!tse,tag=!shift] at @s run function bs_disabled');
          player.runCommandAsync('execute as @s[tag=bs_user,tag=!tse,tag=!unable_skills,tag=!inlight,tag=!bsdisappearing,tag=shift,lm=1] at @s run give @s jjba:bsb');
          player.runCommandAsync('execute as @s[tag=bs_user,tag=!tse,tag=!unable_skills,tag=!inlight,tag=!bsdisappearing,tag=shift,lm=1] at @s run xp -2L @s');
          break;
        case 'jjba:bs_stand_disc':
          player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] blindness 1 10');
          player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] night_vision 2 10 true');
          player.runCommandAsync('execute as @s[tag=!stand_user,tag=!ge_user] at @s run function bs_stand_up');
          break;
        case 'jjba:bspilot':
          player.runCommandAsync('execute as @s[tag=bs_user,tag=!tse,tag=!unable_skills,tag=!inlight,tag=!bsdisappearing] at @s run function bspilot');
          break;
        case 'jjba:bscrow':
          player.runCommandAsync('execute as @s[tag=bs_user,tag=!tse,tag=!unable_skills,tag=!inlight,tag=!bsdisappearing,tag=!bsp1] at @s run function bscrowstart');
          break;
        case 'jjba:bsr':
          player.runCommandAsync('execute as @s[tag=bs_user,tag=!tse,tag=!unable_skills,tag=!inlight,tag=!bsdisappearing,tag=!bsp1] at @s run function bsrstart');
          break;
        case 'jjba:bsr1':
          player.runCommandAsync('execute as @s[tag=bs_user,tag=!tse,tag=!unable_skills,tag=!inlight,tag=!bsin,tag=!bsdisappearing,tag=!bsp1,tag=!shift] at @s run function bsrin');
          player.runCommandAsync('execute as @s[tag=bs_user,tag=!tse,tag=!unable_skills,tag=!inlight,tag=!bsdisappearing,tag=!bsp1,tag=shift] at @s run function bsrout');
          break;
        case 'jjba:bsp':
          player.runCommandAsync('execute as @s[tag=bs_user,tag=!tse,tag=!bsdisappearing,tag=!unable_skills] at @s run function bspstart');
          break;
        default:
          return;
      }
    }
  });
});
