import { world } from "@minecraft/server";

const trackedItems = [
    "minecraft:torch",
    "minecraft:redstone_torch",
    "minecraft:glowstone",
    "minecraft:sea_lantern",
    "minecraft:sea_pickle",
    "minecraft:lantern",
    "minecraft:soul_lantern",
    "minecraft:lava_cauldron",
    "minecraft:flowing_lava",
    "minecraft:campfire",
    "minecraft:soul_campfire",
    "minecraft:carved_pumpkin"
];

world.afterEvents.entitySpawn.subscribe((event) => {
    const { entity } = event;
    if (entity.typeId !== "minecraft:item") return;

    const item = entity.getComponent("item").itemStack;
    if (!trackedItems.includes(item.typeId)) return;

    const bsActivePlayers = world.getPlayers({ tags: ["bs_active"] });
    if (bsActivePlayers.length === 0) return;

    const closestPlayers = entity.dimension.getEntities({
        type: "minecraft:player",
        location: entity.location,
        maxDistance: 2,
    });

    const player = closestPlayers.find(p => 
        p.getRotation().x === entity.getRotation().x &&
        p.getRotation().y === entity.getRotation().y &&
        !p.hasTag("bs_user")
    );

    if (player) {
        player.addTag("bstarget");
        bsActivePlayers.forEach(activePlayer => 
            activePlayer.sendMessage(`§a${item.typeId}§r was dropped by §2${player.nameTag}§r,use first skill to punish them`)
        );
    }
});
