import { world, system } from "@minecraft/server";

function handleEntityTagsAndTeleport(entity) {
    const entityTags = entity.getTags();

    if (entityTags.includes("bsr2") && !entityTags.includes("teleported_bsr2")) {
        const nether = world.getDimension("nether");
        if (nether) {
            nether.runCommandAsync(`execute in nether run tp @e[tag=bsr2] ~ ~200 ~`);
            entity.addTag("teleported_bsr2");
        }
    }

    if (entityTags.includes("bsr10") && !entityTags.includes("teleported_bsr10")) {
        const overworld = world.getDimension("overworld");
        if (overworld) {
            overworld.runCommandAsync(`execute in overworld run tp @e[tag=bsr2] ~ ~200 ~`);
            entity.addTag("teleported_bsr10");
        }
    }
}

system.runInterval(() => {
    const activePlayers = [...world.getPlayers()].filter(player => player.hasTag("bs_active"));
    if (activePlayers.length === 0) return;

    for (const player of world.getPlayers()) {
        handleEntityTagsAndTeleport(player);
    }
}, 1);
