import { world } from "@minecraft/server";

world.afterEvents.entityHurt.subscribe((eventData) => {
    const entity = eventData.hurtEntity;
    const damageSource = eventData.damageSource;

    const validEntitiesWoy = ["jjba:woy", "jjba:woy1", "jjba:woy2", "jjba:woy10"];
    const validEntitiesSpso = ["jjba:star_platinum_stone_so"];
    const validEntitiesGER = ["jjba:golden_experience_requiem1", "jjba:golden_experience_requiem2",
        "jjba:golden_experience_requiem",
        "jjba:golden_experience_requiem3"];
    const validEntitiesNR = ["jjba:nr1"];
    const validEntitiesJH = ["jjba:jh"];
    const validEntitiesKISS = ["jjba:kiss"];
    const validEntitiesDT = ["jjba:dt"];
    const validEntitiesSK = ["jjba:sk"];
    const validEntitiesWS = ["jjba:white_snake1"];
    const validEntitiesSW = ["jjba:sw"];
    const validEntitiesKCR = ["jjba:kcr", "jjba:kcrh", "jjba:kcrt"];
    const validEntitiesSWG = ["jjba:swg"];
    const validEntitiesSCR = ["jjba:scr"];
    const validEntitiesSFF = ["jjba:stone_free1"];
    const validEntitiesTWOH = [
        "jjba:the_world_over_heaven1", "jjba:the_world_over_heaven2",
        "jjba:the_world_over_heaven3", "jjba:the_world_over_heaven4",
        "jjba:the_world_over_heaven5"
    ];
    const validEntitiesCM = ["jjba:c_moon"];
    const validEntitiesMIH = ["jjba:made_in_heaven"];

    if (entity) {
        const damageAmount = eventData.damage;

        if (entity.hasTag("sticker1")) {
            return;
        }

        if (validEntitiesWoy.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("WOY_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["wou_active"] })) {
                player.runCommandAsync(`damage @s[tag=wou_active,tag=!WOY_pilot] ${damageAmount}`);
            }
            entity.runCommandAsync('function hitwoy');
        }

        if (validEntitiesSpso.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("spso_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["spso_active"] })) {
                player.runCommandAsync(`damage @s[tag=spso_active] ${damageAmount}`);
            }
        }

        if (validEntitiesWS.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("ws_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["ws_active"] })) {
                player.runCommandAsync(`damage @s[tag=ws_active,tag=!shift] ${damageAmount}`);
            }
        }

        if (validEntitiesDT.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("dt_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["dt_active"] })) {
                player.runCommandAsync(`damage @s[tag=dt_active] ${damageAmount}`);
            }
        }

        if (validEntitiesKISS.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("k_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["k_active"] })) {
                player.runCommandAsync(`damage @s[tag=k_active] ${damageAmount}`);
            }
        }

        if (validEntitiesSK.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("sk_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["sk_active"] })) {
                player.runCommandAsync(`damage @s[tag=sk_active] ${damageAmount}`);
            }
        }

        if (validEntitiesGER.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("ger_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["ger_active"] })) {
                player.runCommandAsync(`damage @s[tag=ger_active] ${damageAmount}`);
            }
        }

        if (validEntitiesNR.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("nr_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["nr_active"] })) {
                player.runCommandAsync(`damage @s[tag=nr_active] ${damageAmount}`);
            }
        }

        if (validEntitiesJH.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("jh_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["jh_active"] })) {
                player.runCommandAsync(`damage @s[tag=jh_active] ${damageAmount}`);
            }
        }

        if (validEntitiesSW.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("sw_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["sw_active"] })) {
                player.runCommandAsync(`damage @s[tag=sw_active] ${damageAmount}`);
            }
        }

        if (validEntitiesSWG.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("sw_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["sw_active"] })) {
                player.runCommandAsync(`damage @s[tag=sw_active] ${damageAmount}`);
            }
        }

        if (validEntitiesKCR.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("kcr_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["kcr_active"] })) {
                player.runCommandAsync(`damage @s[tag=kcr_active] ${damageAmount}`);
            }
        }

        if (validEntitiesSCR.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("scr_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["scr_active"] })) {
                player.runCommandAsync(`damage @s[tag=scr_active,tag=!scr_pilot] ${damageAmount}`);
            }
        }

        if (validEntitiesSFF.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("sff_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["sff_active"] })) {
                player.runCommandAsync(`damage @s[tag=sff_active] ${damageAmount}`);
            }
        }

        if (validEntitiesTWOH.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("twoh_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["twoh_active"] })) {
                player.runCommandAsync(`damage @s[tag=twoh_active] ${damageAmount}`);
            }
        }

        if (validEntitiesCM.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("cm_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["cm_active"] })) {
                player.runCommandAsync(`damage @s[tag=cm_active] ${damageAmount}`);
            }
        }

        if (validEntitiesMIH.includes(entity.typeId)) {
            if (damageSource && damageSource.damagingEntity && damageSource.damagingEntity.typeId === "minecraft:player" && damageSource.damagingEntity.hasTag("mih_user")) {
                return;
            }
            for (const player of world.getPlayers({ tags: ["mih_active"] })) {
                player.runCommandAsync(`damage @s[tag=mih_active] ${damageAmount}`);
            }
        }
    }
});
