import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skilldt', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:dt_active_control':
          player.runCommandAsync('execute as @s[tag=dt_user,tag=!tse] at @s run function dt_active');
          break;
        case 'jjba:dt_disabled_control':
          player.runCommandAsync('execute as @s[tag=dt_user,tag=!tse] at @s run function dt_disabled');
          break;
        case 'jjba:dt_a':
          player.runCommandAsync('execute as @s[tag=dt_user,tag=!tse,tag=!unable_skills] at @s run function dt_s');
          break;
        case 'jjba:dt_stand_disc':
          player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] blindness 1 10');
          player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] night_vision 2 10 true');
          player.runCommandAsync('execute as @s[tag=!stand_user,tag=!ge_user] at @s run function dt_stand_up');
          break;
        case 'jjba:dt_m1':
          player.runCommandAsync('execute as @s[tag=dt_user,tag=!tse,tag=!dtsc,tag=!unable_skills] at @s run function dt_m1');
          break;
        case 'jjba:dt_r':
          player.runCommandAsync('execute as @s[tag=dt_user,tag=!tse,tag=!unable_skills] at @s run function dt_r');
          break;
        case 'jjba:dt_w':
          player.runCommandAsync('execute as @s[tag=dt_user,tag=!tse,tag=!dtsc,tag=!unable_skills] at @s run function dt_wr');
          break;
        default:
          return;
      }
    }
  });
});
