import { world } from "@minecraft/server";

world.afterEvents.entityDie.subscribe(async (eventData) => {
    const entity = eventData.deadEntity;

    if (entity && !entity.hasTag("sticker1")) { // Check if the entity exists and does NOT have the 'sticker0tp' tag
        const entityPosition = entity.location;

        if (entity.hasTag("sticker0")) {
            await entity.runCommandAsync("tp @e[tag=sticker1] ~ ~-1000 ~");
            await entity.runCommandAsync("kill @e[tag=sticker1]");
        }

        if (entity.typeId === "jjba:scrnps") {
            await entity.runCommandAsync(`tp @a[tag=scr_user] ${entityPosition.x} ${entityPosition.y} ${entityPosition.z}`);
            await entity.runCommandAsync("execute if entity @a[tag=scr_pilot] run execute at @a[tag=scr_active] run function scr_pilot1");
        }

        if (entity.typeId === "jjba:woynps") {
            await entity.runCommandAsync(`tp @a[tag=WOY_user] ${entityPosition.x} ${entityPosition.y} ${entityPosition.z}`);
            await entity.runCommandAsync("execute if entity @a[tag=WOY_pilot] run execute at @a[tag=wou_active] run function WOY_pilot1");
        }

        if (entity.typeId === "jjba:alskill1" || entity.typeId === "jjba:alskill11") {
            await entity.runCommandAsync("function alskill1died");
        }

        if (entity.typeId === "jjba:alskill3") {
            await entity.runCommandAsync("function alskill3end");
        }

        if (entity.typeId === "jjba:trex") {
            await entity.runCommandAsync("function scmtrexdeath");
        }

        if (entity.typeId === "jjba:bsflower1") {
            await entity.runCommandAsync("playsound bsflower @a[r=4] ~ ~ ~");
        }

        if (entity.typeId === "jjba:bsflower2") {
            await entity.runCommandAsync("playsound bsflower @a[r=4] ~ ~ ~");
        }

        if (entity.typeId === "jjba:bs") {
            await entity.runCommandAsync("execute if entity @e[tag=inlight] run summon jjba:crow ~ ~1.8 ~");
        }

        if (entity.typeId === "jjba:sticker1") {
            await entity.runCommandAsync("particle nika:stickerdestoryed ~ ~ ~");
            await entity.runCommandAsync("execute unless entity @e[tag=sticker0] run particle nika:stickerdestoryed1 ~ ~ ~");
        }

        if (entity.typeId === "jjba:bsrealm") {
            await entity.runCommandAsync("execute at @e[tag=bse2] run execute in overworld run tp @e[tag=bsr2] ~ ~100 ~");
            await entity.runCommandAsync("execute at @e[tag=bs_stand] run execute in overworld run tp @e[tag=bs_stand] ~ ~100 ~");
        }

        if (entity.typeId === "jjba:dino") {
            await entity.runCommandAsync("function scmtrexdeath");
        }

        if (entity.typeId === "jjba:alskill5") {
            await entity.runCommandAsync("function alskill5died");
        }

        if (entity.typeId === "jjba:crow") {
            await entity.runCommandAsync("tag @e[tag=inlight] remove inlight");
        }

        if (entity.typeId === "jjba:crow1") {
            await entity.runCommandAsync("camerashake add @a[tag=bs_user] 0.3 0.3 positional");
        }

        if (entity.typeId === "jjba:crow2") {
            await entity.runCommandAsync("camerashake add @a[tag=bs_user] 0.3 0.3 positional");
        }

        if (entity.typeId === "jjba:plane") {
            await entity.runCommandAsync("function planehit");
        }

        if (entity.typeId === "jjba:wou") {
            await entity.runCommandAsync("particle nika:woy_aura2 ~ ~0.8 ~");
        }

        if (entity.typeId === "jjba:star_platinum_so") {
            await entity.runCommandAsync("kill @a[tag=spso_active]");
        }

        if (entity.typeId === "jjba:golden_experience_requiem") {
            await entity.runCommandAsync("kill @a[tag=ger_active,tag=!rt]");
        }

        if (entity.typeId === "jjba:golden_experience_requiem1" || 
            entity.typeId === "jjba:golden_experience_requiem2" || 
            entity.typeId === "jjba:golden_experience_requiem3") {
            await entity.runCommandAsync("kill @a[tag=ger_active]");
        }

        if (entity.typeId === "jjba:nr1") {
            await entity.runCommandAsync("kill @a[tag=nr_active]");
        }

        if (entity.typeId === "jjba:kiss") {
            await entity.runCommandAsync("kill @a[tag=k_active]");
        }

        if (entity.typeId === "jjba:woy") {
            await entity.runCommandAsync("kill @a[tag=wou_active,tag=!WOY_pilot]");
        }

        if (entity.typeId === "jjba:jh") {
            await entity.runCommandAsync("kill @a[tag=jh_active]");
        }

        if (entity.typeId === "jjba:sw") {
            await entity.runCommandAsync("kill @a[tag=sw_active]");
        }

        if (entity.typeId === "jjba:swg") {
            await entity.runCommandAsync("kill @a[tag=sw_active]");
        }

        if (entity.typeId === "jjba:kcr" || 
            entity.typeId === "jjba:kcrh" || 
            entity.typeId === "jjba:kcrt") {
            await entity.runCommandAsync("kill @a[tag=kcr_active]");
        }

        if (entity.typeId === "jjba:scr") {
            await entity.runCommandAsync("kill @a[tag=scr_active,tag=!scr_pilot]");
        }

        if (entity.typeId === "jjba:stone_free1") {
            await entity.runCommandAsync("kill @a[tag=sff_active]");
        }

        if (entity.typeId === "jjba:the_world_over_heaven1" || 
            entity.typeId === "jjba:the_world_over_heaven2" || 
            entity.typeId === "jjba:the_world_over_heaven3" || 
            entity.typeId === "jjba:the_world_over_heaven4" || 
            entity.typeId === "jjba:the_world_over_heaven5") {
            await entity.runCommandAsync("kill @a[tag=twoh_active]");
        }

        if (entity.typeId === "jjba:c_moon") {
            await entity.runCommandAsync("kill @a[tag=cm_active]");
        }

        if (entity.typeId === "jjba:white_snake1") {
            await entity.runCommandAsync("kill @a[tag=ws_active,tag=!shift]");
        }

        if (entity.typeId === "jjba:sk") {
            await entity.runCommandAsync("kill @a[tag=sk_active]");
        }

        if (entity.typeId === "jjba:dt") {
            await entity.runCommandAsync("kill @a[tag=dt_active]");
        }

        if (entity.typeId === "jjba:made_in_heaven") {
            await entity.runCommandAsync("kill @a[tag=mih_active]");
        }
    }
});
