import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skill', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:requiem_arrow':
          player.runCommandAsync('execute as @s[tag=ge_user,r=1] at @s[r=1] run function req1');
          player.runCommandAsync('execute as @s[tag=kc_user] at @s run function req1');
          player.runCommandAsync('execute as @s[tag=sc_user] at @s run function req1');
          break;
        case 'jjba:rokaka':
          player.runCommandAsync('execute as @s at @s run function getsw');
          break;
        case 'jjba:s_remove_disc1':
          player.runCommandAsync('execute as @s[tag=ger_user] at @s run function ger_remove');
          player.runCommandAsync('execute as @s[tag=spso_user] at @s run function spso_remove');
          player.runCommandAsync('execute as @s[tag=k_user] at @s run function k_remove');
          player.runCommandAsync('execute as @s[tag=tw_user1] at @s run function tw_remove1');
          player.runCommandAsync('execute as @s[tag=nr_user] at @s run function nr_remove');
          player.runCommandAsync('execute as @s[tag=kcr_user] at @s run function kcr_remove');
          player.runCommandAsync('execute as @s[tag=deal_active] at @s run function alastor_remove');
          player.runCommandAsync('execute as @s[tag=sk_user] at @s run function sk_remove');
          player.runCommandAsync('execute as @s[tag=sw_user] at @s run function sw_remove');
          player.runCommandAsync('execute as @s[tag=scr_user,tag=!scr_pilot] at @s run function scr_remove');
          player.runCommandAsync('execute as @s[tag=pj_user] at @s run function pj_remove');
          player.runCommandAsync('execute as @s[tag=scm_user] at @s run function scm_remove');
          player.runCommandAsync('execute as @s[tag=sff_user] at @s run function sff_remove');
          player.runCommandAsync('execute as @s[tag=jh_user] at @s run function jh_remove');
          player.runCommandAsync('execute as @s[tag=dt_user] at @s run function dt_remove');
          player.runCommandAsync('execute as @s[tag=bs_user] at @s run function bs_remove');
          player.runCommandAsync('execute as @s[tag=WOY_user] at @s run function WOY_remove');    
          break;
        case 'jjba:stand_arrow':
          player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function stand_arrow');
          break;
        case 'jjba:stand_arrow_100':
          player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function stand_arrow_gs');
          break;
        case 'jjba:bsb':
          player.runCommandAsync('execute as @s at @s run function bsb');
          break;
        case 'jjba:rt_l5_book':
          player.runCommandAsync('execute as @s at @s run function rt_l5');
          break;
        case 'jjba:stand_arrow_for_sdplus':
          player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function stand_arrow1');
          break;
        default:
          return;
      }
    }
  });
});
