import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillkiss', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:k_pb_control':
          player.runCommandAsync('execute as @s[tag=k_user,tag=!tse,tag=!unable_skills] at @s run function k_pb_active');
          break;
        case 'jjba:k_punch':
          player.runCommandAsync('execute as @s[tag=k_user,tag=!tse,tag=!skgg,tag=!unable_skills] at @s run function k_pstart');
          break;
        case 'jjba:k_kiss1':
          player.runCommandAsync('execute as @s[tag=k_user,tag=!tse,tag=!unable_skills] at @s run function kiss1start');
          break;
        case 'jjba:k_active_control':
          player.runCommandAsync('execute as @s[tag=k_user,tag=!tse] at @s run function k_active');
          break;
        case 'jjba:k_disabled_control':
          player.runCommandAsync('execute as @s[tag=k_user,tag=!tse,tag=!shift] at @s run function k_disabled');
          player.runCommandAsync('execute as @s[tag=k_user,tag=shift,tag=kiss0,tag=!unable_skills,tag=!tse] at @s run function kissrock');
          break;
        case 'jjba:k_stand_disc':
          player.runCommandAsync('effect @s[tag=!stand_user] blindness 1 10');
          player.runCommandAsync('effect @s[tag=!stand_user] night_vision 2 10 true');
          player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function k_stand_up');
          break;
        case 'jjba:k_kiss2':
          player.runCommandAsync('execute at @s if entity @e[tag=sticker1] run execute as @s[tag=k_user,tag=!shift,tag=!unable_skills,tag=!tse] at @s run function kiss2end');
         player.runCommandAsync('execute at @s unless entity @e[tag=sticker1] run execute as @s[tag=k_user,tag=shift,tag=!unable_skills,tag=!tse] at @s run function kiss2start');
          break;
        default:
          return;
      }
    }
  });
});
