import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillnr', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:nr_active_control':
          player.runCommandAsync('execute as @s[tag=nr_user,tag=!tse] at @s run function nr_active');
          break;
        case 'jjba:nr_disabled_control':
          player.runCommandAsync('execute as @s[tag=nr_user,tag=!nrr,tag=!tse] at @s run function nr_disabled');
          break;
        case 'jjba:nr_stand_disc':
          player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] blindness 1 10');
          player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] night_vision 2 10 true');
          player.runCommandAsync('execute as @s[tag=!stand_user,tag=!ge_user] at @s run function nr_stand_up');
          break;
        case 'jjba:nr_rain':
          player.runCommandAsync('execute as @s[tag=nr_user,tag=!tse,tag=!nrr,tag=!unable_skills] at @s run function nr_rain');
          break;
        case 'jjba:nr_s':
          player.runCommandAsync('execute as @s[tag=nr_user,tag=!tse,tag=!nrr,tag=!unable_skills] at @s run function nr_s');
          break;
        default:
          return;
      }
    }
  });
});
