import { world, system } from "@minecraft/server";

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        if (player.hasTag("scm_active")) {
            const velocity = player.getVelocity();
            const isSprinting = velocity.x > 0 || velocity.z > 0;

            if (isSprinting) {
                if (!player.hasTag("sprinting")) {
                    player.addTag("sprinting");
                }
            } else {
                if (player.hasTag("sprinting")) {
                    player.removeTag("sprinting");
                }
            }
        }
    }
}, 1);
