import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillscr', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:scr_pb_control':
            player.runCommandAsync('execute as @s[tag=scr_user,tag=!tse,tag=!unable_skills] at @s run function scr_pb');
            break;
        case 'jjba:scr_d':
            player.runCommandAsync('execute as @s[tag=scr_user,tag=!tse,tag=!unable_skills] at @s run function scr_d');
            break;
        case 'jjba:scr_s':
            player.runCommandAsync('execute as @s[tag=scr_user,tag=!tse,tag=!unable_skills] at @s run function scr_s');
            break;
        case 'jjba:scr_active_control':
            player.runCommandAsync('execute as @s[tag=scr_user,tag=!tse] at @s run function scr_active');
            break;
        case 'jjba:scr_disabled_control':
            player.runCommandAsync('execute as @s[tag=scr_user,tag=!tse] at @s run function scr_disabled');
            break;
        case 'jjba:scr_pilot':
            player.runCommandAsync('execute as @s[tag=scr_user,tag=!tse,tag=!unable_skills] at @s run function scr_pilot');
            break;
        case 'jjba:scr_pilot1':
            player.runCommandAsync('execute as @s[tag=scr_user,tag=!tse,tag=!unable_skills] at @s run function scr_pilot1');
            break;
        case 'jjba:scr_stand_disc':
            player.runCommandAsync('effect @s[tag=!stand_user] blindness 1 10');
            player.runCommandAsync('effect @s[tag=!stand_user] night_vision 2 10 true');
            player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function scr_stand_up');
            break;
        default:
            return;
      }
    }
  });
});
