import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillwoy', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:woy_active_control':
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse] at @s run function WOY_active');
          break;
        case 'jjba:woy_disabled_control':
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse,tag=!shift,tag=!woystop] at @s run function WOY_disabled');
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse,tag=shift,tag=!WOY_pilot,tag=!autopilot,tag=!woystop] at @s run function WOY_pilot');
          player.runCommandAsync('execute as @s[tag=!tse,tag=!shift,tag=WOY_pilot,tag=!autopilot,tag=!woystop] at @s run function WOY_pilot1');
          break;
        case 'jjba:woy_disaster':
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse,tag=!woystop,tag=!unable_skills] at @s run function WOY_disaster');
          break;
        case 'jjba:autopilot':
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse,tag=!shift,tag=!unable_skills] at @s run function autopilot1');
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse,tag=shift,tag=!unable_skills] at @s run function autopilot2');
          break;
        case 'jjba:woyplane':
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse,tag=!woystop,tag=!unable_skills] at @s run function woyplane');
          break;
        case 'jjba:woy_stand_disc':
          player.runCommandAsync('effect @s[tag=!stand_user] blindness 1 10');
          player.runCommandAsync('effect @s[tag=!stand_user] night_vision 2 10 true');
          player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function WOY_stand_up');
          break;
        case 'jjba:woy_pb_control':
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse,tag=!woystop,tag=!unable_skills] at @s run function WOY_df');
          break;
        case 'jjba:woy_pilot1':
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse,tag=!woystop,tag=!unable_skills] at @s run function WOY_pilot1');
          break;
        case 'jjba:woy_pilot':
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse,tag=!woystop,tag=!unable_skills] at @s run function WOY_pilot');
          break;
        case 'jjba:woy_rain':
          player.runCommandAsync('execute as @s[tag=WOY_user,tag=!tse,tag=!woystop,tag=!unable_skills] at @s run function WOY_rain');
          break;
        default:
          return;
      }
    }
  });
});
